﻿using System;

namespace BC3Technologies.Common.Mobile
{
	public static class ConnectedExecution
	{
		public static void Run(Action action, Action failureHandler)
		{
			if (!System.Net.NetworkInformation.NetworkInterface.GetIsNetworkAvailable())
			{
				if (failureHandler != null)
				{
					failureHandler();
				}
			}
			else
			{
				action();
			}
		}

		async public static void RunAsync(Action action, Action failureHandler, int timeoutMs = 1000)
		{
			var checkResult = await NetworkInformationUtility.GetNetworkTypeTaskAsync(timeoutMs);
			if (checkResult.HasInternet)
			{
				action();
			}
			else
			{
				failureHandler();
			}
		}
	}
}
